<?php 
/*Check that it is alright to run the comments file now.*/
if ("comments.php" == basename($_SERVER["SCRIPT_FILENAME"])) die ("Please don't do that.");
if ( !empty($post->post_password) && $_COOKIE["wp-postpass_" . COOKIEHASH] != $post->post_password) return; 
/* Make sure comments are only executed on pages and posts and not attachments. It's nice to be able to comment on attachments, it's not nice not 
being able to turn off the comments on them without cheating. Even when you do cheat, typing the post id into the edit URL, you end up breaking 
the page_parent connection. :( 
Most of the following code is in place to avoid redundant tags showing up when elements are disabled and to attach classes to tags under different circumstances. */
if ((pings_open() || comments_open() || $comments) && (!is_attachment() && (is_single() || is_page()))) {?>
	<div id="comments-block">
		<a name="comments"></a><?php
		/* If there are any comments, pings or trackbacks show them otherwise skip this bit to keep things titdy. */
		if ($comments) {?>
			<div class="comments-trackbacks-pings">
				<h2 id="comment-title"><?php comments_number(__("No approved comments."), __("1 Comment"), "% Comments"); ?></h2>
				<a href="<?php the_permalink();?>#respond"><?php _e("Add your own comment");/*Add this here as if there are no comments in the way there is no point putting the skip comments link in. */?></a> 
				<ol id="commentlist"><?php
					$commentalt = true; /*So the first comment is marked as alternate and is highlighted, help show the start point of comments. */
					foreach ($comments as $comment) {
						/* Set up the comments class to allow highlighting of author and alternate comments also a class for not yet approved comments*/
						$comment_class = array(); /* Set up a blank array for me to array_push into. */
						if ($commentalt){ array_push($comment_class,"alternate"); $commentalt = false;} else $commentalt = true; /* Highlight every other comment. */
						if ($comment->user_id == $post->post_author) array_push($comment_class,"author"); /* Is the comment being made by the post Author. */
						if ($comment->comment_approved == 0) array_push($comment_class,"unapproved"); /* Is the comment approved. */
						/* Turn the array created above to a sting and wrap it in a class="" for echoing.*/
						if (is_array($comment_class) && count($comment_class)) {
							$the_class=implode(" ",$comment_class);
							$comment_class="class=\"$the_class\" ";
							unset($the_class);
						} else unset($comment_class);
						/* Echo out the actual comment. */ ?>
						<li id="comment-<?php comment_ID();?>" <?php echo $comment_class;?>>
							<div class="comment-body">
								<div class="comment-header">
									<? echo ($comment->comment_approved == 0 ? "<div class=\"approval\"><em>".__("Your comment is not yet approved.")."</em></div>" : "");?>
									<?php comment_type(__("Comment by "),__("Trackback from "),__("Pingback from "));?><?php comment_author_link() ?>
									<?php if (function_exists("get_avatar")) echo get_avatar( $comment, 24 ,"identicon");?>
								</div>
								<div class="comment-text">
									<?php comment_text();?>
								</div>
								<div class="comment-footer">
									<?php comment_date() ?> <?php comment_time() ?>, <a href="<?php echo get_permalink();?>#comment-<?php comment_ID() ?>"><?php _e("link");?></a><?php edit_comment_link(__("Edit This"), ", ");?>
								</div>
							</div>
						</li><?php
					} ?>
				</ol>
				<div id="comments_rss_link">
					<?php comments_rss_link(__("Comments feed")." <img class=\"comment-rss-link\" src=\"".get_bloginfo("template_directory")."/core/feed-icon-16x16.gif\" alt=\"".__("Comments feed")."\" />");?>
				</div>
			</div>
		<?php }
		/* If commenting is allowed  for the page/post then show the comment form otherwise shut up, not really much point telling people what they can't do.*/
		if (comments_open() && (is_page() || is_single())) { ?>
			<div class="new-comment">
			<a name="respond"></a><?php/* d'oh! ie doesn't like self closing anchors. That was confusing. */?>
			<h2 id="new-comment-title"><?php _e("Please leave a comment");?></h2><?php
			/*If registration is required and you are not logged in then prompt for login else show the normal form.*/ 
			if (get_option("comment_registration") && !$user_ID ) {?>
				<p>You must be <a href="<?php echo get_option("siteurl"); ?>/wp-login.php?redirect_to=<?php the_permalink(); ?>">logged in</a> to comment.</p><?php
			} else { ?>
				<form action="<?php echo get_option("siteurl"); ?>/wp-comments-post.php" method="post" id="commentform"><?php  
				if ($user_ID) { ?>
					<p><?php _e("Logged in as");?> <a href="<?php echo get_option("siteurl"); ?>/wp-admin/profile.php"><?php echo $user_identity; ?></a>. <a href="<?php echo get_option("siteurl"); ?>/wp-login.php?action=logout" title="<?php _e("Log out of this account") ?>">Logout &raquo;</a></p><?php
				} else { ?>
					<p><input type="text" name="author" id="author" value="<?php echo $comment_author; ?>" size="30" tabindex="1" />
					<label for="author"><small><?php _e("Name");?> <?php if ($req) _e("(required)"); ?></small></label></p>
					<p><input type="text" name="email" id="email" value="<?php echo $comment_author_email; ?>" size="30" tabindex="2" />
					<label for="email"><small><?php _e("Mail (will not be published)");?> <?php if ($req) _e("(required)"); ?></small></label></p>
					<p><input type="text" name="url" id="url" value="<?php echo $comment_author_url; ?>" size="30" tabindex="3" />
					<label for="url"><small><?php _e("Website");?> </small></label></p><?php
				} ?>
				<p><textarea name="comment" id="comment" cols="74" rows="10" tabindex="4"></textarea></p>
				<p style="text-align:right;"><input name="submit" type="submit" tabindex="5" value="<?php _e("Post your comment");?>" class="submit" />
				<input type="hidden" name="comment_post_ID" value="<?php echo $id; ?>" />
				</p><?php
				do_action("comment_form", $post->ID); /* Call the comment form action. */ ?>
				</form><?php
			}?>
			</div><?php
		}
		/*Show the trackback link for Pages and posts. */
		if (pings_open() && !is_attachment() && !is_page()) {?>
			<div class="trackback-url">
				<a href="<?php trackback_url() ?>" rel="trackback"><?php _e("TrackBack Address.");?></a>
			</div><?php
		}?>
	</div><?php
}?>